------------------------------------------------------------------------------
-- MakeMeGetMyMain - Alarms you when something happens to your character
------------------------------------------------------------------------------
-- Trigger_Kill.lua - Triggerd on player death
--
-- Author: Expelliarm5s / March 2022 / All Rights Reserved
--
-- Version 1.1.14
------------------------------------------------------------------------------
-- luacheck: ignore 212 globals DLAPI

local addonName, addon = ...
local modle = addon:NewModule("Kill", "AceEvent-3.0", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale(addonName)
-- local private = {}
------------------------------------------------------------------------------

function modle:ModuleName()
	return modle.moduleName
end

function modle:ToggleMod()
	addon.db.global[modle.moduleName] = addon.db.global[modle.moduleName] or false
	addon.db.global[modle.moduleName] = not addon.db.global[modle.moduleName]
	if addon.db.global[modle.moduleName] then
		addon:Printf(L["Module %s enabled"], modle.moduleName)
	else
		addon:Printf(L["Module %s disabled"], modle.moduleName)
	end
end

function modle:EnableMod()
	addon.db.global[modle.moduleName] = true
	addon:Printf(L["Module %s enabled"], modle.moduleName)
end

function modle:DisableMod()
	addon.db.global[modle.moduleName] = false
	addon:Printf(L["Module %s disabled"], modle.moduleName)
end

function modle:Login()
	modle:RegisterEvent("PLAYER_DEAD")
end

function modle:ModuleIcon()
	if addon.isClassic then
		return "INTERFACE\\ICONS\\INV_Misc_Bone_HumanSkull_01"
	else
		return "INTERFACE\\ICONS\\Spell_Deathknight_Necroticplague"
	end
end

function modle:TriggerName()
	return L["Character got killed!"]
end

function modle:TriggerDesc()
	return L["Alarm fires on character death."]
end

function modle:PLAYER_DEAD(event)
	addon:DebugPrintf(modle.moduleName .. "~  %s", tostring(event))
	if event == "PLAYER_DEAD" then
		if addon.isEnabled and addon.db.global[modle.moduleName] then
			addon:DebugPrintf(modle.moduleName .. "~  -> GUI:Fire(%s)", modle.moduleName)
			addon:Printf("Module " .. modle.moduleName .. ": " .. modle:TriggerName())
			if addon.GUI.Fire then
				addon.GUI:Fire(modle.moduleName)
			end
		end
	end
end

-- EOF